Subject: bug#18499: Possible mv race for hardlinks (rhbz #1141368 )

From: Pádraig Brady <[email-masked]>
Date: Fri, 21 Nov 2014 14:39:35 +0000

On 21/11/14 11:53, Pádraig Brady wrote:
> On 21/11/14 08:29, Boris Ranto wrote:
>> On Fri, 2014-11-21 at 03:30 +0000, Pádraig Brady wrote:
>>> We want to leave the logic in place for cp and install though,
>>> and I've adjusted your patch accordingly. I've also adjusted
>>> the tests to pass and augmented the tests to cover one of
>>> the cases missed in the previous patch.  I'll push this tomorrow.
>>>
>>> thanks,
>>> Pádraig.
>>
>> Just a note: cp already presented this behaviour before the patch, i.e. 
>>
>> cp a b
>>
>> on hard links to the same file failed with 
>>
>> cp: ‘a’ and ‘b’ are the same file
>>
>> On the other hand, install does not present it, it copies over b
>> creating new inode for b.
> 
> Yep, but there were other cases with `cp -a` with hardlinks
> to symlinks, and cp --remove-destination a b.
> 
> I've pushed that now.

For reference I've made the kernel renameat() suggestion at:
http://marc.info/?l=linux-api&m=141658005205610&w=2

Pádraig.